'''
Created on 03/04/2011

@author: emea
'''
import pygame

class AnimatedSprite(pygame.sprite.Sprite):
    def __init__(self, images, fps = 10):
        """
        images contains the list of images to loop
        """
        
        pygame.sprite.Sprite.__init__(self)
        self.images = images

        self.start = pygame.time.get_ticks()
        self.delay = 1000 / fps
        self.last_update = 0
        self.frame = 0

        self.update(pygame.time.get_ticks())

    def update(self, t):

        if t - self.last_update > self.delay:
            self.frame += 1
            if self.frame >= len(self.images): self.frame = 0
            self.image = self.images[self.frame]
            self.last_update = t