'''
Created on 06/04/2011

@author: emea
'''

import pygame
from pygame.sprite import Sprite
import SpriteSheet
import os
import AnimatedSprite

class Dancer(Sprite):
    (MOVEMENT, NORMAL1, NORMAL2) = range(3)
    def __init__(self, screen, com_player):
        self.screen = screen
        self.counter = 0
        if com_player == "player":
            spritesheet = os.path.join("data", "DancingPlayerSprites.png")
            x = 100
            y = 330
        else:
            spritesheet = os.path.join("data", "DancerComSprites.png")
            x = 510
            y = 330
        self.image_normal1 = SpriteSheet.image_at(0, 170, 240, spritesheet)
        self.image_normal2 = SpriteSheet.image_at(1, 170, 240, spritesheet)
        self.image_left_up = SpriteSheet.image_at(2, 170, 240, spritesheet)
        self.image_up = SpriteSheet.image_at(3, 170, 240, spritesheet)
        self.image_right_up = SpriteSheet.image_at(4, 170, 240, spritesheet)
        self.image_left = SpriteSheet.image_at(5, 170, 240, spritesheet)
        self.image_middle = SpriteSheet.image_at(6, 170, 240, spritesheet)
        self.image_right = SpriteSheet.image_at(7, 170, 240, spritesheet)
        self.image_left_down = SpriteSheet.image_at(8, 170, 240, spritesheet)
        self.image_down = SpriteSheet.image_at(9, 170, 240, spritesheet)
        self.image_right_down = SpriteSheet.image_at(10, 170, 240, spritesheet)
        
        self.image = self.image_normal1
        self.state = self.NORMAL1
        
        self.rect = self.image.get_rect()
        self.rect.x = x
        self.rect.y = y
    
    def update(self):
        if self.state == self.MOVEMENT:
            if self.counter > 0:
                self.counter = self.counter - 1
            else:
                self.state = self.NORMAL1
        else:
            if self.counter > 0:
                self.counter = self.counter - 1
            else:
                if self.state == self.NORMAL1:
                    self.state = self.NORMAL2
                    self.image = self.image_normal1
                    self.counter = 3
                elif self.state == self.NORMAL2:
                    self.state = self.NORMAL1
                    self.image = self.image_normal2
                    self.counter = 3    
    
    def draw(self):
        self.screen.blit(self.image, self.rect)
    
    def move_left_up(self, time):
        self.image = self.image_left_up
        self.counter = 1 + time
        self.state = self.MOVEMENT
    
    def move_up(self, time):
        self.image = self.image_up
        self.counter = 1 + time
        self.state = self.MOVEMENT
    
    def move_right_up(self, time):
        self.image = self.image_right_up
        self.counter = 1 + time
        self.state = self.MOVEMENT
    
    def move_left(self, time):
        self.image = self.image_left
        self.counter = 1 + time
        self.state = self.MOVEMENT
    
    def move_middle(self, time):
        self.image = self.image_middle
        self.counter = 1 + time
        self.state = self.MOVEMENT
    
    def move_right(self, time):
        self.image = self.image_right
        self.counter = 1 + time
        self.state = self.MOVEMENT
    
    def move_left_down(self, time):
        self.image = self.image_left_down
        self.counter = 1 + time
        self.state = self.MOVEMENT
    
    def move_down(self, time):
        self.image = self.image_down
        self.counter = 1 + time
        self.state = self.MOVEMENT
    
    def move_right_down(self, time):
        self.image = self.image_right_down
        self.counter = 1 + time
        self.state = self.MOVEMENT