'''
Created on 03/04/2011

@author: emea
'''
import pygame
import sys
import os
import data
import AnimatedSprite
import SpriteSheet
import Dancer

class Intro(object):
    (SPEAKING, SALSA_DANCER, GIRL_GOES, BARMAN_SPEAKS) = range(4)
    def __init__(self, screen, music):
        self.INTRO_IMAGE1 = data.filepath("background.png")
        self.GIRL = data.filepath("Girl.png")
        self.BARMAN = data.filepath("Barman.png")
        self.PLAYER_DANCER = data.filepath("DancingPlayerSprites.png")
        self.SALSA = data.filepath("DancingComSprites.png")
        self.HEART = data.filepath("Heart.png")
        self.MUSIC_FILE = data.filepath("MyLatinDanceClass.ogg")
        
        self.music = music
        if self.music:
            pygame.mixer.music.load(self.MUSIC_FILE) 

        self.screen = screen
        self.intro_image1 = pygame.image.load(self.INTRO_IMAGE1).convert()
        

        self.girl = AnimatedSprite.AnimatedSprite(SpriteSheet.images_list(170,240, self.GIRL))
        self.girl_rect = self.girl.image.get_rect()
        self.girl_rect.x = 100
        self.girl_rect.y = 200
        
        self.barman = AnimatedSprite.AnimatedSprite(SpriteSheet.images_list(80,90, self.BARMAN))
        self.barman_rect = self.barman.image.get_rect()
        self.barman_rect.x = 55
        self.barman_rect.y = 165
        
        self.player = AnimatedSprite.AnimatedSprite([SpriteSheet.image_at(0, 170, 240, self.PLAYER_DANCER), SpriteSheet.image_at(1, 170, 240, self.PLAYER_DANCER)])
        self.player_rect = self.player.image.get_rect()
        self.player_rect.x = 35
        self.player_rect.y = 220
        
        self.heart = AnimatedSprite.AnimatedSprite(SpriteSheet.images_list(50,50, self.HEART))
        self.heart_rect = self.heart.image.get_rect()
        self.heart_rect.x = 150
        self.heart_rect.y = 180
        
        self.font = pygame.font.Font(data.filepath("VT321.ttf"), 20)
        self.text_image1 = self.font.render("", 1, (255, 255, 255))
        self.text_image1_rect = self.text_image1.get_rect()
        self.text_image1_rect.x = 100
        self.text_image1_rect.y = 50
        self.text_image2 = self.font.render("", 1, (255, 255, 255))
        self.text_image2_rect = self.text_image2.get_rect()
        self.text_image2_rect.x = 100
        self.text_image2_rect.y = 75
        
        self.text_image3 = self.font.render("", 1, (80, 72, 234))
        self.text_image3_rect = self.text_image3.get_rect()
        self.text_image3_rect.x = 100
        self.text_image3_rect.y = 150
        
        self.text_image4 = self.font.render("", 1, (252, 23, 5))
        self.text_image4_rect = self.text_image4.get_rect()
        self.text_image4_rect.x = 150
        self.text_image4_rect.y = 250
        
        self.com_dancer = Dancer.Dancer(self.screen, "computer")
        
        self.clock = pygame.time.Clock()   
        
        self.state = self.SPEAKING

    def quit(self):
        '''Exit the game
        '''
        
        sys.exit()
    
    def start(self):
        self.intro = self.intro_image1
        bg_rect = self.intro_image1.get_rect()
        counter = 0
        skip_intro = False
        while True:
            if self.music:
                if not pygame.mixer.music.get_busy():
                    pygame.mixer.music.play()
            time_passed = self.clock.tick(30)

            for event in pygame.event.get():
                if event.type == pygame.QUIT:
                    self.quit()
                elif event.type == pygame.KEYDOWN:
                    if event.key == pygame.K_ESCAPE or event.key == pygame.K_q:
                        if self.music:
                            pygame.mixer.music.fadeout(400)
                        skip_intro = True
            if skip_intro == True:
                break
            if self.state == self.SPEAKING:
                if counter <= 200:
                    self.text_image1 = self.font.render("Paco and Julia were dancing and speaking happily when something happened...", 1, (255, 255, 255))
                    self.girl.update(pygame.time.get_ticks())
                    self.barman.update(pygame.time.get_ticks())
                    self.player.update(pygame.time.get_ticks())
                if counter > 200:
                    self.text_image1 = self.font.render("", 1, (255, 255, 255))
                    self.text_image2 = self.font.render("", 1, (255, 255, 255))
                    self.state = self.SALSA_DANCER
                    #break
                
            elif self.state == self.SALSA_DANCER:
                self.text_image1 = self.font.render("...the best salsa dancer ever seen in the world, appeared dancing", 1, (255, 255, 255))
                self.text_image2 = self.font.render("his best dancing...", 1, (255, 255, 255))
                if counter >= 200 and counter <= 205:
                    self.com_dancer.move_down(8)
                if counter >= 206 and counter <= 210:
                    self.com_dancer.move_left_up(8)
                if counter >= 211 and counter <= 215:
                    self.com_dancer.move_right_up(8)
                if counter >= 216 and counter <= 220:
                    self.com_dancer.move_middle(8)
                if counter >= 221 and counter <= 225:
                    self.com_dancer.move_down(8)
                if counter >= 226 and counter <= 230:
                    self.com_dancer.move_left_up(8)
                if counter >= 231 and counter <= 235:
                    self.com_dancer.move_right_up(8)
                if counter >= 236 and counter <= 240:
                    self.com_dancer.move_middle(8)
                if counter >= 241 and counter <= 245:
                    self.com_dancer.move_left_up(16)
                if counter > 300:
                    self.text_image1 = self.font.render("", 1, (255, 255, 255))
                    self.text_image2 = self.font.render("", 1, (255, 255, 255))
                    self.state = self.GIRL_GOES
                    
                self.com_dancer.update()
            elif self.state == self.GIRL_GOES:
                self.text_image1 = self.font.render("...and Julia couldn't avoid falling in love all of a sudden.", 1, (255, 255, 255))
                if counter > 300 and counter < 345:
                    self.girl_rect.x = self.girl_rect.x + 7
                    self.girl_rect.y = self.girl_rect.y + 3
                    self.heart_rect.x = self.heart_rect.x + 7
                    self.heart_rect.y = self.heart_rect.y + 3
                if counter > 500:
                    self.text_image1 = self.font.render("", 1, (255, 255, 255))
                    self.text_image2 = self.font.render("", 1, (255, 255, 255))
                    self.state = self.BARMAN_SPEAKS
                self.girl.update(pygame.time.get_ticks())
                self.heart.update(pygame.time.get_ticks())
                self.com_dancer.update()
            elif self.state == self.BARMAN_SPEAKS:
                if counter > 500 and counter < 600:
                    self.text_image3 = self.font.render("pssssss psssssssssssss... I know how you could get back the girl...", 1, (80, 72, 234))
                if counter > 600 and counter < 650:
                    self.text_image3 = self.font.render("", 1, (80, 72, 234))
                    self.text_image4 = self.font.render("??? and what should I do?", 1, (252, 23, 5))
                if counter > 650 and counter < 750:
                    self.text_image3 = self.font.render("you must challenge the salsa dancer to 9 rounds.", 1, (80, 72, 234))
                    self.text_image4 = self.font.render("", 1, (252, 23, 5))
                if counter > 750 and counter < 850:
                    self.text_image3 = self.font.render("if you win, you will capture the girls heart again.", 1, (80, 72, 234))
                    self.text_image4 = self.font.render("", 1, (252, 23, 5))    
                if counter > 850 and counter < 900:
                    self.text_image3 = self.font.render("", 1, (80, 72, 234))
                    self.text_image4 = self.font.render("Thank you! I will do it!", 1, (252, 23, 5))
                if counter > 900:
                    if self.music:
                        pygame.mixer.music.fadeout(400)
                    break
                self.girl.update(pygame.time.get_ticks())
                self.heart.update(pygame.time.get_ticks())
                self.com_dancer.update()
                pass
            
            counter = counter + 1
            self.screen.blit(self.intro, bg_rect)
            if self.state == self.SPEAKING:
                pass
            elif self.state == self.SALSA_DANCER:
                self.com_dancer.draw()
            elif self.state == self.GIRL_GOES:
                self.com_dancer.draw()
                self.screen.blit(self.heart.image, self.heart_rect)
            elif self.state == self.BARMAN_SPEAKS:
                self.com_dancer.draw()
                self.screen.blit(self.heart.image, self.heart_rect)
            self.screen.blit(self.girl.image, self.girl_rect)
            self.screen.blit(self.barman.image, self.barman_rect)
            self.screen.blit(self.player.image, self.player_rect)
            self.screen.blit(self.text_image1, self.text_image1_rect)
            self.screen.blit(self.text_image2, self.text_image2_rect)
            self.screen.blit(self.text_image3, self.text_image3_rect)
            self.screen.blit(self.text_image4, self.text_image4_rect)
            pygame.display.flip()