'''
Created on 04/04/2011

@author: emea
'''
import pygame
import sys
import os
import data
import Computer
import Dancer
import Player
import ScorePanel
import AnimatedSprite
import SpriteSheet

class Play(object):
    

    (ROUND, COM_DANCING, WAIT_TIME1, PLAYER_DANCING, RESULT_ROUND, WIN_PLAYER, WIN_COM, GAME_STOPPED) = range(8)
    (NOT_DANCING1, DANCING1, END_DANCING1, NOT_DANCING2, DANCING2, END_DANCING2, NOT_DANCING3, DANCING3, END_DANCING3) = range(9)
    
    def __init__(self, screen, music=True):
        self.BACKGROUND_IMAGE = data.filepath("background.png")
        self.MUSIC_FILE = data.filepath("MyLatinDanceClass.ogg")
        self.COM_TEXT = data.filepath("com_text.png")
        self.PLAYER_TEXT = data.filepath("player_text.png")
        self.SOUND_OK = data.filepath("chirrin.ogg")
        self.SOUND_NO_OK = data.filepath("mock.ogg")
        self.GIRL = data.filepath("Girl.png")
        self.BARMAN = data.filepath("Barman.png")
        self.girl = AnimatedSprite.AnimatedSprite(SpriteSheet.images_list(170,240, self.GIRL))
        self.girl_rect = self.girl.image.get_rect()
        self.girl_rect.x = 320
        self.girl_rect.y = 200
        
        self.barman = AnimatedSprite.AnimatedSprite(SpriteSheet.images_list(80,90, self.BARMAN))
        self.barman_rect = self.barman.image.get_rect()
        self.barman_rect.x = 55
        self.barman_rect.y = 165
        
        
        self.screen = screen
        self.music = music
        self.background_image = pygame.image.load(self.BACKGROUND_IMAGE).convert()
        self.com_text = pygame.image.load(self.COM_TEXT).convert_alpha()
        self.com_text_rect = self.com_text.get_rect()
        self.com_text_rect.x = 370
        self.com_text_rect.y = 520
        self.player_text = pygame.image.load(self.PLAYER_TEXT).convert_alpha()
        self.player_text_rect = self.player_text.get_rect()
        self.player_text_rect.x = 220
        self.player_text_rect.y = 520
        self.sound_ok = pygame.mixer.Sound(self.SOUND_OK)
        self.sound_no_ok = pygame.mixer.Sound(self.SOUND_NO_OK)
        
        self.clock = pygame.time.Clock()
        self.paused = False
        self.state = self.ROUND
        self.round_number = 1
        self.round_counter = 100
        self.wait_time_counter1 = 50
        self.wait_time_counter2 = 100
        self.dancing_phase = 0 #there 3 phases per round
        self.state_com_dancing = self.NOT_DANCING1
        self.state_player_dancing = self.NOT_DANCING1
        self.dance_result = 1
        self.player_score = 0
        self.com_score = 0
        self.com_dancer = Dancer.Dancer(self.screen, "computer")
        self.player_dancer = Dancer.Dancer(self.screen, "player")
        self.computer = Computer.Computer(self.com_dancer)
        self.player = Player.Player(self.player_dancer)
        self.font = pygame.font.Font(data.filepath("VT321.ttf"), 60)
        self.font2 = pygame.font.Font(data.filepath("VT321.ttf"), 40)
        self.score_panel = ScorePanel.ScorePanel(self.screen)
        self.result_text_image = self.font2.render("", 1, (255, 255, 255))
        self.result_text_image_rect = self.result_text_image.get_rect()
        
        if self.music:
            pygame.mixer.music.load(self.MUSIC_FILE)   
        
        
    # probably not necessary
    def quit(self):
        """Exit the game
        """
        # force to close; I don't know why the sys.exit(0) doesn't work correctly
        os._exit(0)
        #sys.exit()
    
    def draw(self):
        
        self.screen.blit(self.background_image, self.background_image.get_rect())
        self.com_dancer.draw()
        self.player_dancer.draw()
        if self.state == self.COM_DANCING or self.state == self.WAIT_TIME1:
            self.screen.blit(self.com_text, self.com_text_rect)
        if self.state == self.PLAYER_DANCING:
            self.screen.blit(self.player_text, self.player_text_rect)
        self.score_panel.draw()
        self.screen.blit(self.girl.image, self.girl_rect)
        self.screen.blit(self.barman.image, self.barman_rect)
        if self.state == self.ROUND:
            self.screen.blit(self.text_image, self.text_image_rect)
        if self.state == self.RESULT_ROUND:
            self.screen.blit(self.result_text_image, self.result_text_image_rect)
    
    def play(self):

        # The main loop of the game
        while True:


            time_passed = self.clock.tick(30)
            # game pause; we don't want to jump forward later
            if time_passed > 100:
                continue

            for event in pygame.event.get():
                if event.type == pygame.QUIT:
                    self.quit()
                elif event.type == pygame.KEYDOWN:
                    if event.key == pygame.K_p:
                        self.paused = not self.paused  
                    elif event.key == pygame.K_KP7 or event.key == pygame.K_q:
                        if self.state == self.PLAYER_DANCING:
                            self.player_dancer.move_left_up(2)
                            self.player.move_left_up()
                    elif event.key == pygame.K_KP8 or event.key == pygame.K_w:
                        if self.state == self.PLAYER_DANCING:
                            self.player_dancer.move_up(2)
                            self.player.move_up()
                    elif event.key == pygame.K_KP9 or event.key == pygame.K_e:
                        if self.state == self.PLAYER_DANCING:
                            self.player_dancer.move_right_up(2)
                            self.player.move_right_up()
                    elif event.key == pygame.K_KP4 or event.key == pygame.K_a:
                        if self.state == self.PLAYER_DANCING:
                            self.player_dancer.move_left(2)
                            self.player.move_left()
                    elif event.key == pygame.K_KP5 or event.key == pygame.K_s:
                        if self.state == self.PLAYER_DANCING:
                            self.player_dancer.move_middle(2)
                            self.player.move_middle()
                    elif event.key == pygame.K_KP6 or event.key == pygame.K_d:
                        if self.state == self.PLAYER_DANCING:
                            self.player_dancer.move_right(2)
                            self.player.move_right()
                    elif event.key == pygame.K_KP1 or event.key == pygame.K_z:
                        if self.state == self.PLAYER_DANCING:
                            self.player_dancer.move_left_down(2)
                            self.player.move_left_down()
                    elif event.key == pygame.K_KP2 or event.key == pygame.K_x:
                        if self.state == self.PLAYER_DANCING:
                            self.player_dancer.move_down(2)
                            self.player.move_down()
                    elif event.key == pygame.K_KP3 or event.key == pygame.K_c:
                        if self.state == self.PLAYER_DANCING:
                            self.player_dancer.move_right_down(2)
                            self.player.move_right_down()                                                                                                                 
                    elif event.key == pygame.K_ESCAPE:
                        #self.quit()
                        if self.music:
                            pygame.mixer.music.fadeout(400)
                        return self.GAME_STOPPED

            if not self.paused:
                if self.state == self.ROUND:
                    # show label with the text 'ROUND X'
                    if self.round_counter == 100:
                        self.text_image = self.font.render("Round " + str(self.round_number) + "!", 1, (255, 255, 255))
                        self.text_image_rect = self.text_image.get_rect()
                        self.text_image_rect.centerx = 400
                        self.text_image_rect.centery = 200
                        self.round_counter = self.round_counter - 1
                    elif self.round_counter < 100 and self.round_counter > 0:
                        self.round_counter = self.round_counter - 1
                    else:
                        self.state = self.WAIT_TIME1
                        self.round_counter = 100
                        self.dancing_phase = 0
                        self.state_com_dancing = self.NOT_DANCING1
                        
                elif self.state == self.WAIT_TIME1:
                    if self.music:
                        if not pygame.mixer.music.get_busy():
                            pygame.mixer.music.play()
                    if self.wait_time_counter1 > 0:
                        self.wait_time_counter1 = self.wait_time_counter1 - 1
                        self.computer.update()
                        self.com_dancer.update()
                        self.player.update()
                        self.player_dancer.update()
                        self.girl.update(pygame.time.get_ticks())
                        self.barman.update(pygame.time.get_ticks())
                    else:
                        self.state = self.COM_DANCING
                        self.wait_time_counter1 = 50
                    
                    
                elif self.state == self.COM_DANCING:
                    if self.state_com_dancing == self.NOT_DANCING1:
                        insts = self.computer.generate_instructions(self.score_panel.get_player_score(), self.score_panel.get_com_score())
                        instructions2 = insts[:]
                        
                        self.state_com_dancing = self.DANCING1
                    elif self.state_com_dancing == self.DANCING1:
                        finish_dancing = self.computer.get_state()
                        if finish_dancing == Computer.Computer.END_DANCING:
                            self.state_com_dancing = self.END_DANCING1
                    elif self.state_com_dancing == self.END_DANCING1:
                        self.state = self.PLAYER_DANCING
                        self.state_com_dancing = self.NOT_DANCING1
                        self.dancing_phase = self.dancing_phase + 1
                        
                    self.computer.update()
                    self.com_dancer.update()
                    self.player_dancer.update()
                    self.girl.update(pygame.time.get_ticks())
                    self.barman.update(pygame.time.get_ticks())
                    
                elif self.state == self.PLAYER_DANCING:                                                      
                    if self.dancing_phase <= 2 and self.dance_result == 1: # and player danced correctly the current phase
                        if self.state_player_dancing == self.NOT_DANCING1:
                            self.player.check_instructions(instructions2)
                            self.state_player_dancing = self.DANCING1
                        elif self.state_player_dancing == self.DANCING1:
                            result_dancing = self.player.get_dacing_result()
                            if result_dancing == Player.Player.END_DANCING_OK:
                                self.state_player_dancing = self.END_DANCING1
                                self.sound_ok.play()
                                if self.dancing_phase == 2:
                                    self.state_player_dancing = self.NOT_DANCING1
                                    self.state = self.RESULT_ROUND
                                    if self.music:
                                        pygame.mixer.music.fadeout(400)
                            elif result_dancing == Player.Player.END_DANCING_NO_OK:
                                self.sound_no_ok.play()
                                self.dance_result = 0
                                self.state = self.RESULT_ROUND
                                if self.music:
                                    pygame.mixer.music.fadeout(400)
                                self.state_player_dancing = self.NOT_DANCING1
                                
                        elif self.state_player_dancing == self.END_DANCING1:
                            self.state_player_dancing = self.NOT_DANCING1
                            self.state = self.WAIT_TIME1
                    else:
                        self.state = self.RESULT_ROUND
                        if self.music:
                            pygame.mixer.music.fadeout(400)
                    
                    self.computer.update()
                    self.com_dancer.update()
                    self.player.update()
                    self.player_dancer.update()
                    self.girl.update(pygame.time.get_ticks())
                    self.barman.update(pygame.time.get_ticks())
                    
                elif self.state == self.RESULT_ROUND:
                    if self.wait_time_counter2 == 100:
                        if self.dance_result == 1:
                            self.score_panel.player_win_round()
                            self.result_text_image = self.font2.render("You win the round!", 1, (80, 72, 234))
                            self.result_text_image_rect = self.result_text_image.get_rect()
                            self.result_text_image_rect.centerx = 400
                            self.result_text_image_rect.centery = 200
                        else:
                            self.score_panel.com_win_round()
                            self.result_text_image = self.font2.render("You lose the round!", 1, (80, 72, 234))
                            self.result_text_image_rect = self.result_text_image.get_rect()
                            self.result_text_image_rect.centerx = 400
                            self.result_text_image_rect.centery = 200
                        self.dance_result = 1
                        self.wait_time_counter2 = self.wait_time_counter2 - 1
                    
                    elif self.wait_time_counter2 < 100 and self.wait_time_counter2 > 0:
                        self.wait_time_counter2 = self.wait_time_counter2 - 1
                    else:
                        self.wait_time_counter2 = 100
                        if self.round_number < 9:
                            self.round_number = self.round_number + 1
                            self.state = self.ROUND
                        else:
                            if self.score_panel.get_player_score() < self.score_panel.get_com_score():
                                self.state = self.WIN_COM
                            else:
                                self.state = self.WIN_PLAYER
                    
                elif self.state == self.WIN_PLAYER:
                    return self.WIN_PLAYER
                elif self.state == self.WIN_COM:
                    return self.WIN_COM
            
                

                self.score_panel.update()
                self.draw()

            pygame.display.flip()